RUNS_HUMAN_VERSION	equ	3
	.include	doscall.mac
	.even
	.text
?C0:
	.dc.b 'GIF',$00
?C1:
	.dc.b '87a',$00
?C2:
	.dc.b '89a',$00
	.even
	.globl _loadGIFfile
_loadGIFfile:
	link	a6,#-14
	movem.l	d3/a5,-(sp)
	movea.l	8(a6),a5	*psi
	move.l	#7912,8(a5)	*filebufsize
	pea	28672.l
	DOS	_MALLOC
	move.l	d0,4(a5)	*filebuf
	addq.w	#4,sp
	tst.l	d0
	bpl	memoryok
?200:
	moveq.l	#102,d0
	add.w	d0,d0
	bra	?1
?15:
	move.l	#203,d0
	bra	?1
memoryok:
	move.l	d0,a1
	lea.l	280(a1),a0
	move.l	a0,46(a5)	*readbuf
	lea.l	8192(a1),a0
	move.l	a0,50(a5)	*dic
	lea.l	28672(a1),a0
	move.l	a0,54(a5)	*stack
	moveq.l	#0,d2
	move.l	d2,58(a5)
	move.l	d2,32(a5)	*ZeroDataBlock
	pea	6.w
	pea	-10(a6)
	bsr	_ReadOK
	addq.w	#8,sp
	tst.l	d0
	beq	?15
	pea	3.w
	pea	?C0(OPC)
	pea	-10(a6)
	jbsr	_strncmp
	lea	12(sp),sp
	tst.l	d0
	bne	?13
	pea	3.w
	pea	-7(a6)
	moveq.l	#-14,d3
	add.l	a6,d3
	move.l	d3,-(sp)
	jbsr	_strncpy
	clr.b	-11(a6)
	pea	?C1(OPC)
	move.l	d3,-(sp)
	lea	_strcmp,a4
	jbsr	(a4)
	lea	20(sp),sp
	tst.l	d0
	beq	?6
	pea 	?C2(OPC)
	move.l	d3,-(sp)
	jbsr	(a4)
	addq.w	#8,sp
	tst.l	d0
	beq	?6
?13:
	moveq.l	#101,d0
	add.w	d0,d0
	bra	?1
?6:
	pea	7.w
	pea	-10(a6)
	bsr	_ReadOK
	addq.w	#8,sp
	tst.l	d0
	beq	?15
	moveq.l	#0,d0
	move.b	-6(a6),d0
	moveq.l	#7,d1
	and.b	d0,d1
	moveq.l	#2,d2
	asl.l	d1,d2
	lea.l	66(a5),a1
	move.l	d2,(a1)
	and.b	#128,d0
	cmp.b	#128,d0
	bne	?8
	pea	322(a5)
	move.l	(a1),-(sp)
	bsr	_ReadColorMap
	addq.w	#8,sp
	tst.l	d0
	beq	?15
?8:
	bsr	_nextGIF
	cmp.l	#200,d0
	bne	?1
	moveq.l	#8,d3
	moveq.l	#16,d0
	cmp.l	66(a5),d0
	bcs	gifreadok
	moveq.l	#4,d3
gifreadok:
	move.w	d3,36(a5)
*	move.l	20(a5),d0	*h
*	move.l	d0,d1
*	move.l	24(a5),d2	*v
*	mulu	d2,d0
*	move.l	d0,42(a5)
*	move.l	d0,-(sp)
*	DOS	_MALLOC
*	addq.w	#4,sp
*	tst.l	d0
*	bmi	?200
*	move.l	d0,38(a5)
*	lea.l	_ng,a0
*	move.l	d1,(a0)+	*width
*	move.l	d2,(a0)+	*height
*	move.l	d3,(a0)+	*WindowAttr
*	move.l	d0,(a0)+	*buf
*	lea.l	322(a5),a1
*	move.l	a1,(a0)		*palet
*	bsr	_drawGIF
*	move.l	#201,d0
	moveq.l	#100,d0
	add.w	d0,d0
?1:
	cmp.l	#200,d0
	beq	loadgifend
	move.l	d0,d3
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
loadgifend:
	movem.l	-22(a6),d3/a5
	unlk	a6
	rts
	.even
_nextGIF:
	link	a6,#-12
	movem.l	d3/d4/d5,-(sp)
	lea.l	322(a5),a0
	move.l	a0,d4
?17:
	pea	1.w
	pea	-11(a6)
	bsr	_ReadOK
	addq.w	#8,sp
	tst.l	d0
	beq	eread
	cmp.b	#59,-11(a6)
	bne	notgifterminate
	move.l	#201,d0
	bra	?16
notgifterminate:
	cmp.b	#33,-11(a6)
	bne	notextention
	pea	1.w
	pea	-11(a6)
	bsr	_ReadOK
	addq.w	#8,sp
	tst.l	d0
	beq	eread
	moveq.l	#0,d0
	move.b	-11(a6),d0
	move.l	d0,-(sp)
	bsr	_DoExtension
	addq.w	#4,sp
	tst.w	d0
	bmi	eread
	bra	?17
notextention:
	cmp.b	#',',-11(a6)
	bne	?17
	pea	9.w
	pea	-10(a6)
	bsr	_ReadOK
	addq.w	#8,sp
	tst.l	d0
	beq	eread
	move.b	-2(a6),d0
	move.b	d0,d1
	and.b	#128,d1
	cmp.b	#128,d1
	sne	d2
	moveq.l	#7,d1
	and.b	d0,d1
	addq.w	#1,d1
	moveq.l	#1,d0
	asl.l	d1,d0
	btst	#0,d2
	bne	?26
	move.l	d4,-(sp)
	move.l	d0,-(sp)
	bsr	_ReadColorMap
	addq.w	#8,sp
	tst.l	d0
	beq	eread
?26:
	move.b	-2(a6),d0
	and.b	#64,d0
	cmp.b	#64,d0
	seq	d0
	moveq.l	#1,d5
	and.b	d0,d5
	move.l	d5,-(sp)
	move.l	d4,-(sp)
?32:
	moveq.l	#0,d0
	move.b	-3(a6),d0
	asl.l	#8,d0
	move.b	-4(a6),d0
	move.l	d0,-(sp)
	moveq.l	#0,d0
	move.b	-5(a6),d0
	asl.l	#8,d0
	move.b	-6(a6),d0
	move.l	d0,-(sp)
	bsr	_ReadImage
	tst.l	d0
	bne	normal
eread:
	move.l	#203,d0
	bra	?16
normal:
	moveq.l	#100,d0
	add.w	d0,d0
?16:
	movem.l	-24(a6),d3/d4/d5
	unlk	a6
	rts
	.even
_ReadColorMap:
	link	a6,#-4
	movem.l	d3/a3,-(sp)
	move.l	8(a6),d3	*BitPixel
	move.l	12(a6),a3	*ColorPalet
	pea	3.w
	pea	-4(a6)
	bra	?40
?44:
	bsr	_ReadOK
	tst.l	d0
	bne	?43
	moveq.l	#0,d0
	bra	?39
?43:
	move.b	-3(a6),d0	*G
	lsl.w	#5,d0
	move.b	-4(a6),d0	*R
	lsr.w	#3,d0
	lsl.w	#5,d0
	move.b	-2(a6),d1	*B
	lsr.b	#3,d1
	or.b	d1,d0
	add.w	d0,d0
	move.w	d0,(a3)+
?40:
	dbra	d3,?44
	moveq.l	#1,d0
?39:
	addq.w	#8,sp
	movem.l	(sp)+,d3/a3
	unlk	a6
	rts
	.even
_DoExtension:
	move.l	a4,-(sp)
	lea	4(a5),a4
	moveq.l	#0,d0
	move.b	11(sp),d0
	cmp.b	#249,d0
	bne	?46
	move.l	(a4),-(sp)
	bsr	_GetDataBlock
	tst.l	d0
	bmi	exteread
	addq.w	#4,sp
?46:
	move.l	(a4),-(sp)
?59:
	bsr	_GetDataBlock
	tst.w	d0
	bmi	exteread
	bne	?59
	addq.w	#4,sp
?61:
	moveq.l	#0,d0
	bra	doextend
exteread:
	moveq.l	#-1,d0
	addq.w	#4,sp
doextend:
	move.l	(sp)+,a4
	rts
	.even
_ReadOK:
	move.l	8(sp),d2		*count
	move.l	4(sp),a1		*buf
	move.l	58(a5),d1	*bytecount
	move.l	12(a5),a0	*currentbyte
	bra	?69
?73:
	tst.l	d1		*bytecount
	bne	?71
	move.l	8(a5),-(sp)	*filebufsize
	move.l	46(a5),-(sp)	*readbuf
	move.w	2(a5),-(sp)	*fn
	DOS	_READ
	move.l	d0,d1		*bytecount
	lea	10(sp),sp
	bne	?72
	moveq.l	#0,d0
	bra	?68
?72:
	move.l	46(a5),a0	*currentbyte= readbuf
?71:
	move.b	(a0)+,(a1)+
	subq.l	#1,d1
?69:
	dbra	d2,?73
	moveq.l	#1,d0
?68:
	move.l	d1,58(a5)	*bytecount
	move.l	a0,12(a5)	*currentbyte
	rts
	.even
_ReadImage:
	tst.l	58(a5)		*bytecount
	bne	?147
	move.l	8(a5),-(sp)	*filebufsize
	move.l	46(a5),-(sp)	*readbuf
	move.w	2(a5),-(sp)	*fn
	DOS	_READ
	move.l	d0,58(a5)	*bytecount
	lea	10(sp),sp
	beq	?153
	move.l	46(a5),12(a5)	*currentbyte
?147:
	move.l	12(a5),a0	*currentbyte
	moveq.l	#0,d0
	move.b	(a0),d0		*count
	addq.l	#1,12(a5)	*currentbyte++
	subq.l	#1,58(a5)	*bytecount--
	move.l	d0,-(sp)
	bsr	_LWZInit
	addq.l	#4,sp
	tst.w	d0
	bge	?150
?153:
	moveq.l	#0,d0
	rts
?150:
	moveq.l	#0,d0
	move.w	6(sp),d0	*len
	move.l	d0,20(a5)
	move.w	10(sp),d0	*height
	move.l	d0,24(a5)
	moveq.l	#3,d0
	tst.l	16(sp)		*interlace
	bne	?152
	moveq.l	#-1,d0
?152:
	move.w	d0,144(a5)	*pass
	clr.w	132(a5)		*ypos
	move.w	#8,134(a5)	*addy
	move.l	20(a5),d1
	move.l	d1,d0
	lsl.l	#3,d1
	sub.l	d0,d1
	move.l	d1,136(a5)	*addadd
	moveq.l	#1,d0
?142:
	rts
	.even
_LWZInit:
	move.w	6(sp),d0
	movem.l	d3/d5/d6/d7/a6,-(sp)
	lea	118(a5),a0
	move.w	d0,(a0)		*set_code_size
	addq.w	#1,d0
	move.w	d0,110(a5)	*code_size
	moveq.l	#1,d1
	lsl.w	d0,d1
	subq.w	#1,d1
	move.w	d1,112(a5)	*code_mask
	lea	102(a5),a1
	move.w	(a0),d1
	moveq.l	#1,d0
	lsl.w	d1,d0
	add.w	d0,d0
	add.w	d0,d0
	move.w	d0,(a1)		*clear_code
	move.w	d0,d1
	addq.w	#4,d1
	move.w	d1,104(a5)	*end_code
	addq.w	#4,d1
	move.w	d1,114(a5)	*max_code
	add.w	d0,d0
	move.w	d0,116(a5)	*max_code_size
	moveq.l	#0,d1
	move.w	d1,d3		*curbit
	swap.w	d3
	move.w	d1,d6		*lastbit
	move.w	d1,120(a5)	*done
	move.l	d1,d5
	move.l	12(a5),a6	*getpoint= currentbyte
	move.w	102(a5),d2
	asr.w	#2,d2
	subq.w	#1,d2
	movea.l	50(a5),a0
dirinitlp1:
	move.l	d1,(a0)+
	addq.w	#1,d1
	dbra	d2,dirinitlp1
	moveq.l	#0,d0
	move.w	#4095,d2
	bra	dirinitent2
dirinitlp2:
	move.l	d0,(a0)+
	addq.w	#1,d1
dirinitent2:
	cmp.w	d2,d1
	ble	dirinitlp2
	move.l	58(a5),d7
firstcodelp:
	bsr	_GetCode
	cmp.w	102(a5),d1
	beq	firstcodelp
	move.l	a6,28(a5)	*getpoint= currentbyte
	move.w	d1,d0
	swap.w	d3
	move.w	d3,122(a5)	*curbit
	move.l	d5,150(a5)
	move.w	d6,124(a5)	*lastbit
	move.w	d0,108(a5)
	move.l	d7,58(a5)
	asr.w	#2,d0
	move.w	d0,106(a5)
	move.w	d0,126(a5)	*v
	movem.l	(sp)+,d3/d5/d6/d7/a6
	rts
	.even
_GetDataBlock:
	movea.l	4(sp),a1	*buf
	movea.l	12(a5),a0	*currentbyte
	move.l	58(a5),d2	*bytecount
	bne	countreadable
	movea.l	46(a5),a0	*currentbyte = readbuf
	move.l	8(a5),-(sp)	*filebufsize
	move.l	(a0),-(sp)	*readbuf
	move.w	2(a5),-(sp)	*fn
	DOS	_READ
	lea	10(sp),sp
	move.l	d0,d2		*bytecount
	beq	cantfilbuf
countreadable:
	moveq.l	#0,d1
	move.l	d1,d0
	move.b	(a0)+,d1
	seq	d0
	and.b	#1,d0
	move.l	d0,32(a5)
	move.w	d1,d0
	swap.w	d1
	move.w	d0,d1
	bra	rdwtent
rdwtlp:
	subq.l	#1,d2
	bne	datareadable
	movea.l	46(a5),a0
	move.l	8(a5),-(sp)
	move.l	(a0),-(sp)
	move.w	2(a5),-(sp)
	DOS	_READ
	move.l	d0,d2
	lea	10(sp),sp
	bne	datareadable
cantfilbuf:
	moveq.l	#-1,d0
	bra	getdbreturn
datareadable:
	move.b (a0)+,(a1)+
rdwtent:
	dbra	d1,rdwtlp
	subq.w	#1,d2
	swap.w	d1
	move.w	d1,d0
	ext.l	d0
getdbreturn:
	move.l	a0,12(a5)
	move.l	d2,58(a5)		*bytecount
	rts
	.even
_GetCode:
	move.w	110(a5),d2	*code_size
	sub.w	d2,d6		*code_size <= lastbit
	bcc	?91
	tst.w	120(a5)		*done
	beq	?92
	add.w	d2,d6		*lastbit > 0
	beq	?93
	moveq.l	#-1,d1
	rts
?93:
	moveq.l	#-1,d1
	move.l	d1,32(a5)	*ZeroDataBlock
	rts
?92:
	tst.w	d7		*bytecount
	bne	?94
	move.l	46(a5),a1	*readbuf
	subq.w	#1,a1
	move.l	8(a5),d0
	lea.l	(a1,d0.l),a0
	move.b	(a0),(a1)+
	move.l	d0,-(sp)	*filebufsize
	move.l	a1,-(sp)	*readbuf
	move.w	2(a5),-(sp)	*fn
	DOS	_READ
	lea	10(sp),sp
	move.l	d0,d7		*bytecount
	beq	?93
	move.l	a1,12(a5)	*currentbyte = readbuf
?94:
	lea	12(a5),a1	*currentbyte
	movea.l	(a1),a0
	addq.l	#1,(a1)		*currentbyte++
	subq.w	#1,d7		*bytecount--
	moveq.l	#0,d1
	move.l	d1,d0
	move.b	(a0),d1
	seq	d0
	and.b	#1,d0
	move.l	d0,32(a5)	*ZeroDataBlock
	bne	?95
	cmp.w	d7,d1		*bytecount
	ble	?100
	move.l	8(a5),d0
	sub.l	d0,a6
	movea.l	46(a5),a0	*readbuf
	lea.l	(a0,d0.l),a1	*readbufsize
	move.w	d7,d0		*bytecount
	addq.w	#2,d0
	bra	?97
?99:
	move.b	-(a1),-(a0)
?97:
	dbra	d0,?99
	addq.w	#2,a0
	move.l	a0,12(a5)	*currentbyte
	move.l	8(a5),-(sp)	*readbufsize
	move.l	46(a5),-(sp)	*readbuf
	move.w	2(a5),-(sp)	*fn
	DOS	_READ
	lea	10(sp),sp
	tst.l	d0
	beq	?93
	add.w	d0,d7		*bytecount
	bra	?100
?95:
	move.w	#1,120(a5)	*done
?100:
	lea	12(a5),a1	*currentbyte
	move.l	(a1),a0
	move.b	-2(a0),-1(a0)
	addq.l	#1,a6		*getpoint
	add.l	d1,(a1)		*currentbyte += count
	sub.w	d1,d7		*bytecount -= count
	lsl.w	#3,d1
	add.w	d1,d6		*lastbit += count * 8
?91:
	swap.w	d3
	move.w	d3,d0
	moveq.l	#0,d1
	sub.w	d2,d3		*curbit
	bcc	allbitok
	move.b	(a6)+,d1
	addq.w	#8,d3
	bpl	compose
	addq.w	#8,d3
	swap.w	d0
	move.b	(a6)+,d0
	lsl.w	#8,d0
	or.w	d0,d1
	swap.w	d0
compose:
	lsl.l	d0,d1
allbitok:
	swap.w	d3
	or.l	d5,d1
	move.l	d1,d5
	lsr.l	d2,d5
	and.w	112(a5),d1	*code_mask
	add.w	d1,d1
	add.w	d1,d1
	rts
	.even
	.globl	_drawGIF
_drawGIF:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a5	*psi
	movea.l	54(a5),a3	*sp 62
	move.l	50(a5),a4	*dictop 50
	movea.l 38(a5),a2	*adrs
	move.w	102(a5),d4	*clear_code
	move.w	122(a5),d3	*curbit
	swap.w	d3
	move.l	150(a5),d5
	move.w	124(a5),d6	*lastbit
	move.l	58(a5),d7	*bytecount
	move.l	28(a5),a6	*getpoint= currentbyte
	move.w	126(a5),d0	*v
	move.b	d0,-(a3)	*sp++
ylp:
	move.w	22(a5),d3	*h
?167:
	move.l	54(a5),d1
	sub.l	a3,d1
	beq	_LWZReadByte
	cmp.w	d1,d3
	bhi	allput
	move.w	d3,d1

.ifdef	LOOP
	subq.w	#1,d1
allflushlp:
	move.b	(a3)+,(a2)+
	dbra	d1,allflushlp
.else
	bsr	flush
.endif

	bra	xlpend
allput:
	sub.w	d1,d3

.ifdef	LOOP
	subq.w	#1,d1
flushlp:
	move.b	(a3)+,(a2)+
	dbra	d1,flushlp
.else
	bsr	flush
.endif

	bra	?167
_LWZReadByte:
newcoderead:
	bsr	_GetCode
	blt	ylpbreak
	cmp.w	d4,d1		*clear_code
	bne	endcheck
	moveq.l	#0,d1
	movea.l	a4,a0
	move.w	d4,d2
	subq.w	#1,d2
dirclrlp1:
	move.l	d1,(a0)+
	addq.w	#1,d1
	dbra	d2,dirclrlp1
	moveq.l	#0,d0
	move.w	#4095,d2
	bra	dirclrent2
dirclrlp2:
	move.l	d0,(a0)+
	addq.w	#1,d1
dirclrent2:
	cmp.w	d2,d1
	ble	dirclrlp2
	move.w	118(a5),d1	*set_code_size
	addq.w	#1,d1
	move.w	d1,110(a5)	*code_size
	moveq.l	#1,d0
	lsl.w	d1,d0
	subq.w	#1,d0
	move.w	d0,112(a5)	*code_mask
	move.w	d4,d0		*clear_code
	move.w	d0,d1
	addq.w	#8,d1
	move.w	d1,114(a5)	*max_code
	add.w	d0,d0
	move.w	d0,116(a5)	*max_code_size
	move.l	54(a5),a3	*stacktop
	bsr	_GetCode
	move.w	d1,108(a5)
	add.w	d1,d1
	add.w	d1,d1
	move.w	d1,106(a5)
	move.b	d1,-(a3)
	bra	?167
endcheck:
	cmp.w	104(a5),d1	*end_code
	beq	terminate
normalcode:
	move.w	d1,d2		*incode
	cmp.w	114(a5),d1
	blt	?132
	move.w	106(a5),d1
	move.b	d1,-(a3)
	move.w	108(a5),d1
	bra	?132
?135:
	move.l	(a4,d1.w),d0
	move.b	d0,-(a3)
	swap.w	d0
	cmp.w	d0,d1
	beq	ylpbreak
	move.w	d0,d1
?132:
	cmp.w	d4,d1
	bge	?135
	move.w	2(a4,d1.w),d0
	move.w	d0,106(a5)
	move.b	d0,-(a3)		*sp++
	lea.l	114(a5),a1
	move.w	(a1),d1
	cmp.w	#16384-1,d1
	bgt	?136
	lea.l	(a4,d1.w),a0
	move.w	108(a5),(a0)+
	move.w	d0,(a0)
	addq.w	#4,d1
	move.w	d1,(a1)+
	move.w	(a1),d0
	cmp.w	d1,d0
	bhi	?136
	cmp.w	#16384-1,d0
	bhi	?136
	add.w	d0,(a1)
	lea.l	110(a5),a0
	addq.w	#1,(a0)+
	move.w	(a0),d0
	add.w	d0,d0
	addq.w	#1,d0
	move.w	d0,(a0)
?136:
	move.w	d2,108(a5)
	bra	?167
xlpend:
	lea.l	144(a5),a0
	move.w	(a0),d0			*pass
	bmi	notinterlace
	move.w	134(a5),d1		*addy
	add.w	d1,132(a5)		*ypos
	adda.l	136(a5),a2		*addadd
	move.w	26(a5),d1		*height
	cmp.w	132(a5),d1		*ypos
	bgt	ylp
	subq.w	#1,d0		*pass-
	move.w	d0,(a0)
	bmi	terminate	*pass0
	beq	pass1		*pass1
	subq.w	#2,d0
	bmi	pass2		*2
	bne	ylpbreak	*3<pass
pass3:
	move.w	#4,132(a5)	*ypos = 4
	move.l	20(a5),d0	*h
	lsl.l	#2,d0		*realwidth * 8
	movea.l	38(a5),a2
	adda.l	d0,a2
	bra	ylp
pass1:
	moveq.l	#1,d1
	move.l	20(a5),d0	*h
	move.l	d0,136(a5)
	bra	?182
pass2:
	move.l	20(a5),d0	*h
	move.l	d0,d1
	add.w	d0,d0
	add.l	d0,d1
	move.l	d1,136(a5)	*addadd
	moveq.l	#2,d1
?182:
	move.w	d1,132(a5)	*ypos = 2
	add.w	d1,d1
	move.w	d1,134(a5)	*addy = 4
	movea.l	38(a5),a2
	adda.l	d0,a2
	bra	ylp
notinterlace:
	addq.w	#1,132(a5)	*ypos
	move.w	26(a5),d1	*height
	cmp.w	132(a5),d1
	bgt	ylp
terminate:
	move.l	#201,d0		*PICSLICE_TERMINATE
	bra	endop
ylpbreak:
	move.l	#203,d0		*PICSLICE_EREAD
endop:
	move.l	d0,d3
*	jbsr	_MakeNewGWin
	move.l	a5,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even
	.end
